from django.contrib.auth.backends import ModelBackend
from django.contrib.auth.models import User
from .models import Token


class TokenAuthBackend(ModelBackend):
    """
    Authenticates against token_auth.auth.models.Token.
    """
    supports_inactive_user = True

    def authenticate(self, token=None):
        try:
            return Token.objects.get(value=token).user
        except (User.DoesNotExist, Token.DoesNotExist):
            return None
